ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.2 by root, Wed Mar 7 01:23:37 2007 UTC vs.
Revision 1.52 by root, Sat Aug 18 22:25:35 2007 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@";
12my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@";
13 15
14use Getopt::Long; 16use Getopt::Long;
17use Coro::Event;
18use AnyEvent;
15use IO::AIO; 19use IO::AIO ();
16use File::Temp; 20use File::Temp;
17use Crossfire; 21use Crossfire;
22use Coro;
23use Coro::AIO;
24use Coro::Util;
25use POSIX ();
26use Digest::MD5;
27use Carp;
28use Coro::Storable; $Storable::canonical = 1;
29
30$SIG{QUIT} = sub { Carp::cluck "QUIT" };
18 31
19sub usage { 32sub usage {
20 warn <<EOF; 33 warn <<EOF;
21Usage: cfutil [-v] [-q] [--force] 34Usage: cfutil [-v] [-q] [--force] [--cache]
22 [--install-arch path] 35 [--install-arch path]
23 [--install-maps maps] 36 [--install-maps maps]
24 [--print-statedir] 37 [--print-statedir]
25 [--print-confdir] 38 [--print-confdir]
26 [--print-datadir] 39 [--print-datadir]
29EOF 42EOF
30 exit 1; 43 exit 1;
31} 44}
32 45
33my $VERBOSE = 1; 46my $VERBOSE = 1;
47my $CACHE = 0;
34my $FORCE; 48my $FORCE;
35my $TMPDIR = "/tmp/cfutil$$~"; 49my $TMPDIR = "/tmp/cfutil$$~";
50my $TMPFILE = "aaaa0";
51
52our %COLOR = (
53 black => 0,
54 white => 1,
55 navy => 2,
56 red => 3,
57 orange => 4,
58 blue => 5,
59 darkorange => 6,
60 green => 7,
61 lightgreen => 8,
62 grey => 9,
63 brown => 10,
64 gold => 11,
65 tan => 12,
66);
36 67
37END { system "rm", "-rf", $TMPDIR } 68END { system "rm", "-rf", $TMPDIR }
69
70Event->signal (signal => "INT", cb => sub { exit 1 });
71Event->signal (signal => "TERM", cb => sub { exit 1 });
38 72
39mkdir $TMPDIR, 0700 73mkdir $TMPDIR, 0700
40 or die "$TMPDIR: $!"; 74 or die "$TMPDIR: $!";
41 75
76sub fork_sub(&) {
77 my ($cb) = @_;
78
79 if (my $pid = fork) {
80 my $current = $Coro::current;
81 my $w = AnyEvent->child (pid => $pid, cb => sub { $current->ready });
82 Coro::schedule;
83 } else {
84 eval { $cb->() };
85 POSIX::_exit 0 unless $@;
86 warn $@;
87 POSIX::_exit 1;
88 }
89}
90
42sub inst_maps($) { 91sub inst_maps($) {
43 my (undef, $path) = @_; 92 my (undef, $path) = @_;
44 93
45 print "installing '$path' to '$DATADIR/maps'\n\n"; 94 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
46 95
47 if (!-f "$path/regions") { 96 if (!-f "$path/regions") {
48 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 97 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
49 exit 1 unless $FORCE; 98 exit 1 unless $FORCE;
50 } 99 }
51 100
52 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 101 system $RSYNC, "-a", "--chmod=u=rwX,go=rX", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"
102 and die "map installation failed.\n";
103
104 print "maps installed successfully.\n";
53} 105}
54 106
55{ 107{
56 my @PNG; 108 our %ANIMINFO;
109 our %FACEINFO;
110 our %RESOURCE;
57 my @ARC; 111 our @ARC;
112 our %ARC;
113 our $TRS;
114 our $NFILE;
115 our $PATH;
58 116
117 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
118
119 our (@png, @trs, @arc, @res); # files we are interested in
120
59 sub commit_png { 121 sub commit_png($$$) {
60 my ($name, $data) = @_; 122 my ($name, $data, $T) = @_;
61 #warn "$name: commited\n";
62 }
63 123
64 sub add_png($) { 124 $FACEINFO{$name}{"data$T"} = $data;
125 }
126
127 sub process_png {
128 while (@png) {
129 my ($path, $delete) = @{pop @png};
130
131 my $png;
132 aio_lstat $path;
133 my ($size, $mtime) = (stat _)[7,9];
134
135 if (0 > aio_load $path, $png) {
136 warn "$path: $!, skipping.\n";
137 next;
138 }
139
140 my $stem = $path;
141 my $T;
142
143 if ($stem =~ s/\.32x32\.png~?$//) {
144 $T = 32;
145 } elsif ($stem =~ s/\.64x64\.png~?$//) {
146 $T = 64;
147 } else {
148 warn "$path: weird filename, skipping.\n";
149 next;
150 }
151
152 # quickly extract width and height of the (necessarily PNG) image
153 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
154 warn "$path: not a recognized png file, skipping.\n";
155 next;
156 }
157
158 my ($w, $h) = unpack "NN", $1;
159
160 if ($w < $T || $h < $T) {
161 warn "$path: too small ($w $h), skipping.\n";
162 next;
163 }
164
165 if ($w % $T || $h % $T) {
166 warn "$path: weird png size ($w $h), skipping.\n";
167 next;
168 }
169
170 unless ($path =~ /~$/) {
171 # possibly enlarge
172 if (0 > aio_stat "$stem.64x64.png") {
173 my $other = "$stem.64x64.png~";
174
175 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
176 fork_sub {
177 my $CROP;
178 my $SRC = "png:\Q$path\E";
179
180 # check if this is a wall. ultra-ugly. ultra-ultra-ugly.
181 if ($path =~ /^(.*\/wall\/.*_)([0-9A-F])(\.x11.*\.png)$/) {
182 my ($pfx, $dir, $sfx) = ($1, hex $2, $3);
183 #check for 0..F images to be sure(?) this is a wall
184 unless (grep { !-e sprintf "%s%X%s", $pfx, $_, $sfx } 0..15) {
185 # add a 4px border and add other images around it
186 $CROP = "-shave 8x8 +repage";
187
188 $w += 8;
189 $h += 8;
190
191 $SRC = "-size ${w}x${h} xc:transparent";
192 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
193
194 # 8 surrounding images
195 for (
196 # x y b r0 r1
197 [-1, -1, 0, 6],
198 [ 0, -1, 1, 10, 14],
199 [+1, -1, 0, 12],
200
201 [-1, 0, 8, 5, 7],
202 #
203 [+1, 0, 2, 5, 13],
204
205 [-1, +1, 0, 3],
206 [ 0, +1, 4, 10, 11],
207 [+1, +1, 0, 9],
208 ) {
209 my ($x, $y, $d, $r0, $r1) = @$_;
210 $SRC .= sprintf " png:%s%X%s -geometry %+d%+d -composite",
211 "\Q$pfx",
212 ($dir & $d) ? $r1 : $r0,
213 "\Q$sfx",
214 $x * ($w - 8) + 4,
215 $y * ($h - 8) + 4;
216 }
217 }
218 }
219
220 system "convert -depth 8 $SRC rgba:-"
221 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
222 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
223 and die "convert/cfhq2xa pipeline error: status $? ($!)";
224 system $OPTIPNG, "-i0", "-q", "$other~";
225 die "$other~ has zero size, aborting." unless -s "$other~";
226 rename "$other~", $other;
227 };
228 }
229
230 push @png, [$other, !$CACHE];
231 }
232
233 # possibly scale down
234 if (0 > aio_stat "$stem.32x32.png") {
235 my $other = "$stem.32x32.png~";
236
237 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
238 fork_sub {
239 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
240 system $OPTIPNG, "-i0", "-q", "$other~";
241
242 # reduce smoothfaces >10000 bytes
243 if ($stem =~ /_S\./ && (-s "$other~") > 10000) {
244 my $ncolor = 256;
245 while () {
246 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
247 system $OPTIPNG, "-i0", "-q", "$other~~";
248 last if 10000 > -s "$other~~";
249 $ncolor = int $ncolor * 0.9;
250 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
251 }
252
253 printf "reduced %s from %d to %d bytes using %d colours.\n",
254 $other, -s "$other~", -s "$other~~", $ncolor
255 if $VERBOSE >= 2;
256 rename "$other~~", "$other~";
257 }
258
259 die "$other~ has zero size, aborting." unless -s "$other~";
260 rename "$other~", $other;
261 };
262 }
263
264 #warn "scaled down $path to $other\n";#d#
265 push @png, [$other, !$CACHE];
266 }
267 }
268
269 (my $face = $stem) =~ s/^.*\///;
270
271 # split all bigfaces, but avoid smoothfaces (*_S)
272 if (($w > $T || $h > $T) && $face !~ /_S\./) {
273 # split
274 my @tile;
275 for my $x (0 .. (int $w / $T) - 1) {
276 for my $y (0 .. (int $h / $T) - 1) {
277 my $file = "$path+$x+$y~";
278 aio_lstat $file;
279 push @tile, [$x, $y, $file, (stat _)[9]];
280 }
281 }
282
283 my $mtime = (lstat $path)[9];
284 my @todo = grep { $_->[3] <= $mtime } @tile;
285 if (@todo) {
286 fork_sub {
287 open my $convert, "|-", $CONVERT,
288 "png:-",
289 (map {
290 (
291 "(",
292 "+clone",
293 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
294 "+repage",
295 -quality => "00",
296 -write => "png32:$_->[2]~",
297 "+delete",
298 ")",
299 )
300 } @todo),
301 "null:";
302
303 binmode $convert;
304 print $convert $png;
305 close $convert;
306
307 # pass 2, optimise, and rename
308 for (@todo) {
309 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
310 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
311 rename "$_->[2]~", $_->[2];
312 }
313 };
314 }
315
316 for (@tile) {
317 my ($x, $y, $file) = @$_;
318 my $tile;
319
320 if (0 > aio_load $file, $tile) {
321 die "$path: unable to read tile +$x+$y, aborting.\n";
322 }
323 IO::AIO::aio_unlink $file unless $CACHE;
324 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
325 }
326 } else {
327 # use as-is (either small, use smooth)
328 commit_png $face, $png, $T;
329 }
330
331 aio_unlink $path if $delete;
332 }
333 }
334
335 sub process_arc {
336 while (@arc) {
337 my ($dir, $file) = @{pop @arc};
338
339 my $arc;
340 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
341
342 my $arc = read_arch "$dir/$file";
343 for my $o (values %$arc) {
344 push @ARC, $o;
345 for (my $m = $o; $m; $m = $m->{more}) {
346 $ARC{$m->{_name}} = $m;
347 }
348
349 $o->{editor_folder} = $dir;
350
351 my $visibility = delete $o->{visibility};
352 my $magicmap = delete $o->{magicmap};
353
354 # find upper left corner :/
355 # omg, this is sooo broken
356 my ($dx, $dy);
357 for (my $o = $o; $o; $o = $o->{more}) {
358 $dx = $o->{x} if $o->{x} < $dx;
359 $dy = $o->{y} if $o->{y} < $dy;
360 }
361
362 for (my $o = $o; $o; $o = $o->{more}) {
363 my $x = $o->{x} - $dx;
364 my $y = $o->{y} - $dy;
365
366 my $ext = $x|$y ? "+$x+$y" : "";
367
368 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
369
370 $visibility = delete $o->{visibility} if exists $o->{visibility};
371 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
372
373 my $anim = delete $o->{anim};
374
375 if ($anim) {
376 # possibly add $ext to the animation name to avoid
377 # the need to specify archnames for all parts
378 # of a multipart archetype.
379 $o->{animation} = "$o->{_name}";
380 my $facings = 1;
381 my @frames;
382
383 for (@$anim) {
384 if (/^facings\s+(\d+)/) {
385 $facings = $1*1;
386 } elsif (/^blank.x11$|^empty.x11$/) {
387 push @frames, $_;
388 } else {
389 push @frames, "$_$ext";
390 }
391 }
392
393 $ANIMINFO{$o->{animation}} = {
394 facings => $facings,
395 frames => \@frames,
396 };
397 }
398
399 for my $face ($o->{face} || (), @{$anim || []}) {
400 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/;
401
402 my $info = $FACEINFO{$face} ||= {};
403
404 $info->{visibility} = $visibility if defined $visibility;
405 $info->{magicmap} = $magicmap if defined $magicmap;
406 }
407
408 if (my $smooth = delete $o->{smoothface}) {
409 my %kv =split /\s+/, $smooth;
410 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
411 while (my ($face, $smooth) = each %kv) {
412 $FACEINFO{$face}{smooth} = $smooth;
413 $FACEINFO{$face}{smoothlevel} = $level;
414 }
415 }
416 }
417 }
418 }
419 }
420
421 sub process_trs {
422 while (@trs) {
423 my ($dir, $file) = @{pop @trs};
424 my $path = "$dir/$file";
425
426 my $trs;
427 if (0 > aio_load $path, $trs) {
428 warn "$path: $!, skipping.\n";
429 next;
430 }
431
432 $TRS .= $trs;
433 }
434 }
435
436 my %FILECACHE;
437
438 sub load_cached($;$) {
439 unless (exists $FILECACHE{$_[0]}) {
440 my $data;
441 if (0 < aio_load $_[0], $data) {
442 if ($_[1]) {
443 $data = eval { $_[1]->($data) };
444 warn "$_[0]: $@" if $@;
445 }
446 }
447
448 $FILECACHE{$_[0]} = $data;
449 }
450
451 $FILECACHE{$_[0]}
452 }
453
454 sub process_res {
455 while (@res) {
456 my ($dir, $file, $type) = @{pop @res};
457
458 my $data;
459 aio_load "$dir/$file", $data;
460
461 my $meta = load_cached "$dir/meta", sub { JSON::XS::from_json shift };
462
463 next if $meta && !exists $meta->{$file};
464
465 $meta = {
466 %{ $meta->{"" } || {} },
467 %{ $meta->{$file} || {} },
468 };
469
470 if ($meta->{license} =~ s/^#//) {
471 $meta->{license} = ({
472 "pd" => "Public Domain",
473 "gpl" => "GNU General Public License, version 3.0 or any later",
474 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
475 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.5/",
476 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
477 })->{$meta->{license}}
478 || warn "$dir/$file: license tag '$meta->{license}' not found.";
479 }
480
481 $file =~ s/\.res$//;
482 $file =~ s/\.(ogg|wav|jpg|png)$//;
483
484 substr $dir, 0, 1 + length $PATH, "";
485
486 $RESOURCE{"$dir/$file"} = {
487 type => (delete $meta->{type}) || $type,
488 data => $data,
489 chksum => (Digest::MD5::md5 $data),
490 %$meta ? (meta => $meta) : (),
491 };
492 }
493 }
494
495 sub find_files;
496 sub find_files {
65 my ($path) = @_; 497 my ($path) = @_;
66 498
67 my $png; 499 IO::AIO::aioreq_pri 4;
68 aio_lstat $path, sub { 500 IO::AIO::aio_scandir $path, 4, sub {
69 my ($size, $mtime) = (stat _)[7,9]; 501 my ($dirs, $nondirs) = @_;
70 502
71 aio_load $path, $png, sub { 503 find_files "$path/$_"
72 if ($_[0] < 0) { 504 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
73 warn "$path: $!, skipping.\n";
74 return;
75 }
76 505
77 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 506 my $dir = $path;
78 warn "$path: not a recongized png file, skipping.\n"; 507 substr $dir, 0, 1 + length $PATH, "";
79 return;
80 }
81 508
82 my ($w, $h) = unpack "NN", $1; 509 for my $file (@$nondirs) {
510 if ($dir =~ /^music(?:\/|$)/) {
511 push @res, [$path, $file, 3] # FT_MUSIC
512 if $file =~ /\.(ogg)$/;
83 513
84 (my $face = $path) =~ s/^.*\///; 514 } elsif ($dir =~ /^sound(?:\/|$)/) {
85 my $T = 32; 515 push @res, [$path, $file, 5] # FT_SOUND
516 if $file =~ /\.(wav|ogg)$/;
86 517
87 unless ($face =~ s/\.base\.(...)\.png$/.$1/) { 518 } elsif ($dir =~ /^res(?:\/|$)/) {
88 warn "$path: weird filename, skipping.\n"; 519 push @res, [$path, $file, 0] # FT_FACE
89 return; 520 if $file =~ /\.(jpg|png)$/;
90 } 521 push @res, [$path, $file, 7] # FT_RSRC
522 if $file =~ /\.(res)$/;
91 523
92 if ($w < $T || $h < $T) { 524 } elsif ($file =~ /\.png$/) {
93 warn "$path: too small ($w $h), skipping.\n"; 525 push @png, ["$path/$file", 0];
94 return;
95 }
96 526
97 if ($w % $T || $h % $T) { 527 } elsif ($file =~ /\.trs$/) {
98 warn "$path: weird png size ($w $h), skipping.\n"; 528 push @trs, [$path, $file];
99 return;
100 }
101 529
102 if ($w > $T || $h > $T) { 530 } elsif ($file =~ /\.arc$/) {
103 # split 531 push @arc, [$path, $file];
532
104 } else { 533 } else {
105 # use as-is
106 commit_png $face, $png;
107 }
108
109 #warn "$path: $w, $h\n";
110 };
111 };
112
113 IO::AIO::poll; # reduce file-handle pressure
114 }
115
116 sub add_arc($$) {
117 my ($dir, $file) = @_;
118
119 my $arc;
120 aio_load "$dir/$file", $arc, sub { # simply pre-cache, as read_arch wants a file :/
121 my $arc = read_arch "$dir/$file";
122 };
123 }
124
125 sub add_trs($$) {
126 my ($dir, $file) = @_;
127 }
128
129 sub collect_arch;
130 sub collect_arch {
131 my ($path) = @_;
132
133 aioreq_pri 4;
134 aio_scandir $path, 4, sub {
135 my ($dirs, $nondirs) = @_;
136
137 collect_arch "$path/$_"
138 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
139
140 for my $file (@$nondirs) {
141 if ($file =~ /\.png$/) {
142 add_png "$path/$file";
143 } elsif ($file =~ /\.trs$/) {
144 add_trs $path, $file;
145 } elsif ($file =~ /\.arc$/) {
146 add_arc $path, $file;
147 } else {
148 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 534 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
149 } 535 }
150 } 536 }
151 }; 537 };
152 } 538 }
153 539
154 sub inst_arch($) { 540 sub inst_arch($) {
155 my (undef, $path) = @_; 541 my (undef, $path) = @_;
156 542
543 $PATH = $path;
544
545 print "\n",
157 print "installing '$path' to '$DATADIR'\n\n"; 546 "Installing '$path' to '$DATADIR'\n",
547 "\n",
548 "This can take a long time if you run this\n",
549 "for the first time or do not use --cache.\n",
550 "\n",
551 "Unless you run verbosely, all following warning\n",
552 "or error messages indicate serious problems.\n",
553 "\n";
158 554
159 if (!-d "$path/treasures") { 555 if (!-d "$path/treasures") {
160 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 556 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
161 exit 1 unless $FORCE; 557 exit 1 unless $FORCE;
162 } 558 }
163 559
164 collect_arch $path; 560 find_files $path;
165 IO::AIO::flush; 561 IO::AIO::flush;
166 562
167 die "--install-arch not yet implemented\n"; 563 $_->join for (
564 # four png crunchers work fine for my 2x smp machine
565 (async \&process_png), (async \&process_png), (async \&process_png), (async \&process_png),
566 (async \&process_trs), (async \&process_trs),
567 (async \&process_arc), (async \&process_arc),
568 (async \&process_res), (async \&process_res),
569 );
570
571 {
572 # remove path prefix from editor_folder
573 substr $_->{editor_folder}, 0, 1 + length $path, ""
574 for values %ARC;
575
576 # resolve inherit
577 while () {
578 my $progress;
579 my $loop;
580
581 for my $o (values %ARC) {
582 if (my $other = $o->{inherit}) {
583 if (my $s = $ARC{$other}) {
584 if ($s->{inherit}) {
585 $loop = $s;
586 } else {
587 delete $o->{inherit};
588 my %s = %$s;
589 delete @s{qw(_name more name name_pl)};
590 %$o = ( %s, %$o );
591 ++$progress;
592 }
593 } else {
594 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
595 delete $ARC{$o->{_name}};
596 }
597 }
598 }
599
600 unless ($progress) {
601 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
602 if $loop;
603
604 last;
605 }
606 }
607
608 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
609 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
610
611 open my $fh, ">:utf8", "$DATADIR/archetypes~"
612 or die "$DATADIR/archetypes~: $!";
613 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
614 }
615
616 {
617 open my $fh, ">:utf8", "$DATADIR/treasures~"
618 or die "$DATADIR/treasures~: $!";
619 print $fh $TRS;
620 }
621
622 {
623 while (my ($k, $v) = each %FACEINFO) {
624 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
625 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
626
627 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
628 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
629
630 $v->{chksum32} = Digest::MD5::md5 $v->{data32};
631 $v->{chksum64} = Digest::MD5::md5 $v->{data64};
632
633 if (my $magicmap = $v->{magicmap}) {
634 $magicmap =~ y/A-Z_\-/a-z/d;
635 $v->{magicmap} = $COLOR{$magicmap};
636 }
637 }
638
639 open my $fh, ">:perlio", "$DATADIR/facedata~"
640 or die "$DATADIR/facedata~: $!";
641
642 print $fh freeze {
643 version => 2,
644 faceinfo => \%FACEINFO,
645 animinfo => \%ANIMINFO,
646 resource => \%RESOURCE,
647 };
648 }
649
650 for (qw(archetypes facedata treasures)) {
651 chmod 0644, "$DATADIR/$_~";
652 rename "$DATADIR/$_~", "$DATADIR/$_"
653 or die "$DATADIR/$_: $!";
654 }
655
656 print "archetype data installed successfully.\n";
168 } 657 }
169} 658}
170 659
171Getopt::Long::Configure ("bundling", "no_ignore_case"); 660Getopt::Long::Configure ("bundling", "no_ignore_case");
172GetOptions ( 661GetOptions (
173 "verbose|v:+" => \$VERBOSE, 662 "verbose|v:+" => \$VERBOSE,
663 "cache" => \$CACHE,
174 "quiet|q" => sub { $VERBOSE = 0 }, 664 "quiet|q" => sub { $VERBOSE = 0 },
175 "force" => sub { $FORCE = 1 }, 665 "force" => sub { $FORCE = 1 },
176 "install-arch=s" => \&inst_arch, 666 "install-arch=s" => \&inst_arch,
177 "install-maps=s" => \&inst_maps, 667 "install-maps=s" => \&inst_maps,
178 "print-statedir" => sub { print "@pkgstatedir@\n" }, 668 "print-statedir" => sub { print "@pkgstatedir@\n" },

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines